Package org.apache.cayenne.ejbql

## Class EJBQLBaseVisitor

- java.lang.Object
- - org.apache.cayenne.ejbql.EJBQLBaseVisitor

- All Implemented Interfaces:
    `EJBQLExpressionVisitor`
  Direct Known Subclasses:
    `EJBQLConditionTranslator`, `EJBQLDbPathTranslator`, `EJBQLDeleteTranslator`, `EJBQLFromTranslator`, `EJBQLPathTranslator`, `EJBQLSelectColumnsTranslator`, `EJBQLSelectTranslator`

      public class EJBQLBaseVisitor
      extends Object
      implements EJBQLExpressionVisitor

  A noop implementation of the EJBQL visitor that returns same preset boolean value from all methods. Intended for subclassing.
  Since:
    3.0

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected boolean` | `continueFlag` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `EJBQLBaseVisitor()` |
    `EJBQLBaseVisitor​(boolean continueFlag)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `visitAbs​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitAbstractSchemaName​(EJBQLExpression expression)` |
    `boolean` | `visitAdd​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "add" expression and also after visiting every expression child.
    `boolean` | `visitAggregate​(EJBQLExpression expression)` |
    `boolean` | `visitAll​(EJBQLExpression expression)` |
    `boolean` | `visitAnd​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "and" expression and also after visiting every expression child.
    `boolean` | `visitAny​(EJBQLExpression expression)` |
    `boolean` | `visitAscending​(EJBQLExpression expression)` |
    `boolean` | `visitAverage​(EJBQLAggregateColumn expression)` |
    `boolean` | `visitBetween​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "between" expression and also after visiting every expression child.
    `boolean` | `visitBooleanLiteral​(EJBQLExpression expression)` |
    `boolean` | `visitClassName​(EJBQLExpression expression)` |
    `boolean` | `visitConcat​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitConstructor​(EJBQLExpression expression)` |
    `boolean` | `visitConstructorParameter​(EJBQLExpression expression)` |
    `boolean` | `visitConstructorParameters​(EJBQLExpression expression)` |
    `boolean` | `visitCount​(EJBQLAggregateColumn expression)` |
    `boolean` | `visitCurrentDate​(EJBQLExpression expression)` |
    `boolean` | `visitCurrentTime​(EJBQLExpression expression)` |
    `boolean` | `visitCurrentTimestamp​(EJBQLExpression expression)` |
    `boolean` | `visitDbPath​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitDecimalLiteral​(EJBQLDecimalLiteral expression)` |
    `boolean` | `visitDelete​(EJBQLExpression expression)` |
    `boolean` | `visitDescending​(EJBQLExpression expression)` |
    `boolean` | `visitDistinct​(EJBQLExpression expression)` |
    `boolean` | `visitDivide​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "divide" expression and also after visiting every expression child.
    `boolean` | `visitEquals​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "equals" expression and also after visiting every expression child.
    `boolean` | `visitEscapeCharacter​(EJBQLExpression expression)` |
    `boolean` | `visitExists​(EJBQLExpression expression)` |
    `boolean` | `visitFrom​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitFromItem​(EJBQLFromItem expression, int finishedChildIndex)` |
    `boolean` | `visitGreaterOrEqual​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting ">=" expression and also after visiting every expression child.
    `boolean` | `visitGreaterThan​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting ">=" expression and also after visiting every expression child.
    `boolean` | `visitGroupBy​(EJBQLExpression expression)` |
    `boolean` | `visitHaving​(EJBQLExpression expression)` |
    `boolean` | `visitIdentificationVariable​(EJBQLExpression expression)` |
    `boolean` | `visitIdentifier​(EJBQLExpression expression)` |
    `boolean` | `visitIn​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitInnerFetchJoin​(EJBQLJoin join)` |
    `boolean` | `visitInnerJoin​(EJBQLJoin join)` |
    `boolean` | `visitIntegerLiteral​(EJBQLIntegerLiteral expression)` |
    `boolean` | `visitIsEmpty​(EJBQLExpression expression)` |
    `boolean` | `visitIsNull​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitLength​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitLessOrEqual​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "<=" expression and also after visiting every expression child.
    `boolean` | `visitLessThan​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "<" expression and also after visiting every expression child.
    `boolean` | `visitLike​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "LIKE" expression and also after visiting every expression child.
    `boolean` | `visitLocate​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitLower​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitMax​(EJBQLAggregateColumn expression)` |
    `boolean` | `visitMemberOf​(EJBQLExpression expression)` |
    `boolean` | `visitMin​(EJBQLAggregateColumn expression)` |
    `boolean` | `visitMod​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitMultiply​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "*" expression and also after visiting every expression child.
    `boolean` | `visitNamedInputParameter​(EJBQLExpression expression)` |
    `boolean` | `visitNamedInputParameterForIn​(EJBQLExpression expression)` | This method is invoked from the processing of the `EJBQLIn` in order to handle a query such as;
    `boolean` | `visitNegative​(EJBQLExpression expression)` |
    `boolean` | `visitNot​(EJBQLExpression expression)` |
    `boolean` | `visitNotEquals​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "!=" expression and also after visiting every expression child.
    `boolean` | `visitOr​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "or" expression and also after visiting every expression child.
    `boolean` | `visitOrderBy​(EJBQLExpression expression)` |
    `boolean` | `visitOrderByItem​(EJBQLExpression expression)` |
    `boolean` | `visitOuterFetchJoin​(EJBQLJoin join)` |
    `boolean` | `visitOuterJoin​(EJBQLJoin join)` |
    `boolean` | `visitPath​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "path" expression and also after visiting every expression child.
    `boolean` | `visitPatternValue​(EJBQLExpression expression)` |
    `boolean` | `visitPositionalInputParameter​(EJBQLPositionalInputParameter expression)` |
    `boolean` | `visitPositionalInputParameterForIn​(EJBQLPositionalInputParameter expression)` | This method is invoked from the processing of the `EJBQLIn` in order to handle a query such as;
    `boolean` | `visitSelect​(EJBQLExpression expression)` |
    `boolean` | `visitSelectClause​(EJBQLExpression expression)` |
    `boolean` | `visitSelectExpression​(EJBQLExpression expression)` |
    `boolean` | `visitSelectExpressions​(EJBQLExpression expression)` |
    `boolean` | `visitSize​(EJBQLExpression expression)` |
    `boolean` | `visitSqrt​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitStringLiteral​(EJBQLExpression expression)` |
    `boolean` | `visitSubselect​(EJBQLExpression expression)` |
    `boolean` | `visitSubstring​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitSubtract​(EJBQLExpression expression, int finishedChildIndex)` | Called on visiting "subtract" expression and also after visiting every expression child.
    `boolean` | `visitSum​(EJBQLAggregateColumn expression)` |
    `boolean` | `visitTok​(EJBQLExpression expression)` |
    `boolean` | `visitTrim​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitTrimBoth​(EJBQLExpression expression)` |
    `boolean` | `visitTrimCharacter​(EJBQLExpression expression)` |
    `boolean` | `visitTrimLeading​(EJBQLExpression expression)` |
    `boolean` | `visitTrimTrailing​(EJBQLExpression expression)` |
    `boolean` | `visitUpdate​(EJBQLExpression expression)` |
    `boolean` | `visitUpdateField​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitUpdateItem​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitUpdateValue​(EJBQLExpression expression)` |
    `boolean` | `visitUpper​(EJBQLExpression expression, int finishedChildIndex)` |
    `boolean` | `visitWhere​(EJBQLExpression expression)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### continueFlag

          protected boolean continueFlag

  - ### Constructor Detail

    - #### EJBQLBaseVisitor

          public EJBQLBaseVisitor()

    - #### EJBQLBaseVisitor

          public EJBQLBaseVisitor​(boolean continueFlag)

  - ### Method Detail

    - #### visitAbs

          public boolean visitAbs​(EJBQLExpression expression,
                                  int finishedChildIndex)

      Specified by:
        `visitAbs` in interface `EJBQLExpressionVisitor`

    - #### visitAbstractSchemaName

          public boolean visitAbstractSchemaName​(EJBQLExpression expression)

      Specified by:
        `visitAbstractSchemaName` in interface `EJBQLExpressionVisitor`

    - #### visitAdd

          public boolean visitAdd​(EJBQLExpression expression,
                                  int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "add" expression and also after visiting every expression child.
      Specified by:
        `visitAdd` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "add" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitAggregate

          public boolean visitAggregate​(EJBQLExpression expression)

      Specified by:
        `visitAggregate` in interface `EJBQLExpressionVisitor`

    - #### visitAll

          public boolean visitAll​(EJBQLExpression expression)

      Specified by:
        `visitAll` in interface `EJBQLExpressionVisitor`

    - #### visitAnd

          public boolean visitAnd​(EJBQLExpression expression,
                                  int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "and" expression and also after visiting every expression child.
      Specified by:
        `visitAnd` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "and" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitAny

          public boolean visitAny​(EJBQLExpression expression)

      Specified by:
        `visitAny` in interface `EJBQLExpressionVisitor`

    - #### visitAscending

          public boolean visitAscending​(EJBQLExpression expression)

      Specified by:
        `visitAscending` in interface `EJBQLExpressionVisitor`

    - #### visitAverage

          public boolean visitAverage​(EJBQLAggregateColumn expression)

      Specified by:
        `visitAverage` in interface `EJBQLExpressionVisitor`

    - #### visitBetween

          public boolean visitBetween​(EJBQLExpression expression,
                                      int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "between" expression and also after visiting every expression child.
      Specified by:
        `visitBetween` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "between" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitBooleanLiteral

          public boolean visitBooleanLiteral​(EJBQLExpression expression)

      Specified by:
        `visitBooleanLiteral` in interface `EJBQLExpressionVisitor`

    - #### visitClassName

          public boolean visitClassName​(EJBQLExpression expression)

      Specified by:
        `visitClassName` in interface `EJBQLExpressionVisitor`

    - #### visitConcat

          public boolean visitConcat​(EJBQLExpression expression,
                                     int finishedChildIndex)

      Specified by:
        `visitConcat` in interface `EJBQLExpressionVisitor`

    - #### visitConstructor

          public boolean visitConstructor​(EJBQLExpression expression)

      Specified by:
        `visitConstructor` in interface `EJBQLExpressionVisitor`

    - #### visitConstructorParameter

          public boolean visitConstructorParameter​(EJBQLExpression expression)

      Specified by:
        `visitConstructorParameter` in interface `EJBQLExpressionVisitor`

    - #### visitConstructorParameters

          public boolean visitConstructorParameters​(EJBQLExpression expression)

      Specified by:
        `visitConstructorParameters` in interface `EJBQLExpressionVisitor`

    - #### visitCount

          public boolean visitCount​(EJBQLAggregateColumn expression)

      Specified by:
        `visitCount` in interface `EJBQLExpressionVisitor`

    - #### visitCurrentDate

          public boolean visitCurrentDate​(EJBQLExpression expression)

      Specified by:
        `visitCurrentDate` in interface `EJBQLExpressionVisitor`

    - #### visitCurrentTime

          public boolean visitCurrentTime​(EJBQLExpression expression)

      Specified by:
        `visitCurrentTime` in interface `EJBQLExpressionVisitor`

    - #### visitCurrentTimestamp

          public boolean visitCurrentTimestamp​(EJBQLExpression expression)

      Specified by:
        `visitCurrentTimestamp` in interface `EJBQLExpressionVisitor`

    - #### visitDecimalLiteral

          public boolean visitDecimalLiteral​(EJBQLDecimalLiteral expression)

      Specified by:
        `visitDecimalLiteral` in interface `EJBQLExpressionVisitor`

    - #### visitDelete

          public boolean visitDelete​(EJBQLExpression expression)

      Specified by:
        `visitDelete` in interface `EJBQLExpressionVisitor`

    - #### visitDescending

          public boolean visitDescending​(EJBQLExpression expression)

      Specified by:
        `visitDescending` in interface `EJBQLExpressionVisitor`

    - #### visitDbPath

          public boolean visitDbPath​(EJBQLExpression expression,
                                     int finishedChildIndex)

      Specified by:
        `visitDbPath` in interface `EJBQLExpressionVisitor`

    - #### visitDistinct

          public boolean visitDistinct​(EJBQLExpression expression)

      Specified by:
        `visitDistinct` in interface `EJBQLExpressionVisitor`

    - #### visitDivide

          public boolean visitDivide​(EJBQLExpression expression,
                                     int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "divide" expression and also after visiting every expression child.
      Specified by:
        `visitDivide` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "divide" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitEquals

          public boolean visitEquals​(EJBQLExpression expression,
                                     int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "equals" expression and also after visiting every expression child.
      Specified by:
        `visitEquals` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "equals" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitEscapeCharacter

          public boolean visitEscapeCharacter​(EJBQLExpression expression)

      Specified by:
        `visitEscapeCharacter` in interface `EJBQLExpressionVisitor`

    - #### visitExists

          public boolean visitExists​(EJBQLExpression expression)

      Specified by:
        `visitExists` in interface `EJBQLExpressionVisitor`

    - #### visitFrom

          public boolean visitFrom​(EJBQLExpression expression,
                                   int finishedChildIndex)

      Specified by:
        `visitFrom` in interface `EJBQLExpressionVisitor`

    - #### visitFromItem

          public boolean visitFromItem​(EJBQLFromItem expression,
                                       int finishedChildIndex)

      Specified by:
        `visitFromItem` in interface `EJBQLExpressionVisitor`

    - #### visitGreaterOrEqual

          public boolean visitGreaterOrEqual​(EJBQLExpression expression,
                                             int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting ">=" expression and also after visiting every expression child.
      Specified by:
        `visitGreaterOrEqual` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an ">=" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitGreaterThan

          public boolean visitGreaterThan​(EJBQLExpression expression,
                                          int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting ">=" expression and also after visiting every expression child.
      Specified by:
        `visitGreaterThan` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an ">=" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitGroupBy

          public boolean visitGroupBy​(EJBQLExpression expression)

      Specified by:
        `visitGroupBy` in interface `EJBQLExpressionVisitor`

    - #### visitHaving

          public boolean visitHaving​(EJBQLExpression expression)

      Specified by:
        `visitHaving` in interface `EJBQLExpressionVisitor`

    - #### visitIdentificationVariable

          public boolean visitIdentificationVariable​(EJBQLExpression expression)

      Specified by:
        `visitIdentificationVariable` in interface `EJBQLExpressionVisitor`

    - #### visitIdentifier

          public boolean visitIdentifier​(EJBQLExpression expression)

      Specified by:
        `visitIdentifier` in interface `EJBQLExpressionVisitor`

    - #### visitIn

          public boolean visitIn​(EJBQLExpression expression,
                                 int finishedChildIndex)

      Specified by:
        `visitIn` in interface `EJBQLExpressionVisitor`

    - #### visitInnerFetchJoin

          public boolean visitInnerFetchJoin​(EJBQLJoin join)

      Specified by:
        `visitInnerFetchJoin` in interface `EJBQLExpressionVisitor`

    - #### visitInnerJoin

          public boolean visitInnerJoin​(EJBQLJoin join)

      Specified by:
        `visitInnerJoin` in interface `EJBQLExpressionVisitor`

    - #### visitIntegerLiteral

          public boolean visitIntegerLiteral​(EJBQLIntegerLiteral expression)

      Specified by:
        `visitIntegerLiteral` in interface `EJBQLExpressionVisitor`

    - #### visitIsEmpty

          public boolean visitIsEmpty​(EJBQLExpression expression)

      Specified by:
        `visitIsEmpty` in interface `EJBQLExpressionVisitor`

    - #### visitIsNull

          public boolean visitIsNull​(EJBQLExpression expression,
                                     int finishedChildIndex)

      Specified by:
        `visitIsNull` in interface `EJBQLExpressionVisitor`

    - #### visitLength

          public boolean visitLength​(EJBQLExpression expression,
                                     int finishedChildIndex)

      Specified by:
        `visitLength` in interface `EJBQLExpressionVisitor`

    - #### visitLessOrEqual

          public boolean visitLessOrEqual​(EJBQLExpression expression,
                                          int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "<=" expression and also after visiting every expression child.
      Specified by:
        `visitLessOrEqual` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "<=" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitLessThan

          public boolean visitLessThan​(EJBQLExpression expression,
                                       int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "<" expression and also after visiting every expression child.
      Specified by:
        `visitLessThan` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "<" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitLike

          public boolean visitLike​(EJBQLExpression expression,
                                   int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "LIKE" expression and also after visiting every expression child.
      Specified by:
        `visitLike` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "LIKE" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitLocate

          public boolean visitLocate​(EJBQLExpression expression,
                                     int finishedChildIndex)

      Specified by:
        `visitLocate` in interface `EJBQLExpressionVisitor`

    - #### visitLower

          public boolean visitLower​(EJBQLExpression expression,
                                    int finishedChildIndex)

      Specified by:
        `visitLower` in interface `EJBQLExpressionVisitor`

    - #### visitMax

          public boolean visitMax​(EJBQLAggregateColumn expression)

      Specified by:
        `visitMax` in interface `EJBQLExpressionVisitor`

    - #### visitMemberOf

          public boolean visitMemberOf​(EJBQLExpression expression)

      Specified by:
        `visitMemberOf` in interface `EJBQLExpressionVisitor`

    - #### visitMin

          public boolean visitMin​(EJBQLAggregateColumn expression)

      Specified by:
        `visitMin` in interface `EJBQLExpressionVisitor`

    - #### visitMod

          public boolean visitMod​(EJBQLExpression expression,
                                  int finishedChildIndex)

      Specified by:
        `visitMod` in interface `EJBQLExpressionVisitor`

    - #### visitMultiply

          public boolean visitMultiply​(EJBQLExpression expression,
                                       int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "*" expression and also after visiting every expression child.
      Specified by:
        `visitMultiply` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "*" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitNamedInputParameterForIn

          public boolean visitNamedInputParameterForIn​(EJBQLExpression expression)

      Description copied from interface: `EJBQLExpressionVisitor`

      This method is invoked from the processing of the `EJBQLIn` in order to handle a query such as;

      `p.toArtist IN (:artists)`
      Specified by:
        `visitNamedInputParameterForIn` in interface `EJBQLExpressionVisitor`

    - #### visitNamedInputParameter

          public boolean visitNamedInputParameter​(EJBQLExpression expression)

      Specified by:
        `visitNamedInputParameter` in interface `EJBQLExpressionVisitor`

    - #### visitNegative

          public boolean visitNegative​(EJBQLExpression expression)

      Specified by:
        `visitNegative` in interface `EJBQLExpressionVisitor`

    - #### visitNot

          public boolean visitNot​(EJBQLExpression expression)

      Specified by:
        `visitNot` in interface `EJBQLExpressionVisitor`

    - #### visitNotEquals

          public boolean visitNotEquals​(EJBQLExpression expression,
                                        int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "!=" expression and also after visiting every expression child.
      Specified by:
        `visitNotEquals` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "!=" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitOr

          public boolean visitOr​(EJBQLExpression expression,
                                 int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "or" expression and also after visiting every expression child.
      Specified by:
        `visitOr` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "or" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitOrderBy

          public boolean visitOrderBy​(EJBQLExpression expression)

      Specified by:
        `visitOrderBy` in interface `EJBQLExpressionVisitor`

    - #### visitOrderByItem

          public boolean visitOrderByItem​(EJBQLExpression expression)

      Specified by:
        `visitOrderByItem` in interface `EJBQLExpressionVisitor`

    - #### visitOuterFetchJoin

          public boolean visitOuterFetchJoin​(EJBQLJoin join)

      Specified by:
        `visitOuterFetchJoin` in interface `EJBQLExpressionVisitor`

    - #### visitOuterJoin

          public boolean visitOuterJoin​(EJBQLJoin join)

      Specified by:
        `visitOuterJoin` in interface `EJBQLExpressionVisitor`

    - #### visitPath

          public boolean visitPath​(EJBQLExpression expression,
                                   int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "path" expression and also after visiting every expression child.
      Specified by:
        `visitPath` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - a "path" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitPatternValue

          public boolean visitPatternValue​(EJBQLExpression expression)

      Specified by:
        `visitPatternValue` in interface `EJBQLExpressionVisitor`

    - #### visitPositionalInputParameterForIn

          public boolean visitPositionalInputParameterForIn​(EJBQLPositionalInputParameter expression)

      Description copied from interface: `EJBQLExpressionVisitor`

      This method is invoked from the processing of the `EJBQLIn` in order to handle a query such as;

      `p.toArtist IN (?1)`
      Specified by:
        `visitPositionalInputParameterForIn` in interface `EJBQLExpressionVisitor`

    - #### visitPositionalInputParameter

          public boolean visitPositionalInputParameter​(EJBQLPositionalInputParameter expression)

      Specified by:
        `visitPositionalInputParameter` in interface `EJBQLExpressionVisitor`

    - #### visitSelect

          public boolean visitSelect​(EJBQLExpression expression)

      Specified by:
        `visitSelect` in interface `EJBQLExpressionVisitor`

    - #### visitSelectClause

          public boolean visitSelectClause​(EJBQLExpression expression)

      Specified by:
        `visitSelectClause` in interface `EJBQLExpressionVisitor`

    - #### visitSelectExpression

          public boolean visitSelectExpression​(EJBQLExpression expression)

      Specified by:
        `visitSelectExpression` in interface `EJBQLExpressionVisitor`

    - #### visitSelectExpressions

          public boolean visitSelectExpressions​(EJBQLExpression expression)

      Specified by:
        `visitSelectExpressions` in interface `EJBQLExpressionVisitor`

    - #### visitSize

          public boolean visitSize​(EJBQLExpression expression)

      Specified by:
        `visitSize` in interface `EJBQLExpressionVisitor`

    - #### visitSqrt

          public boolean visitSqrt​(EJBQLExpression expression,
                                   int finishedChildIndex)

      Specified by:
        `visitSqrt` in interface `EJBQLExpressionVisitor`

    - #### visitStringLiteral

          public boolean visitStringLiteral​(EJBQLExpression expression)

      Specified by:
        `visitStringLiteral` in interface `EJBQLExpressionVisitor`

    - #### visitSubselect

          public boolean visitSubselect​(EJBQLExpression expression)

      Specified by:
        `visitSubselect` in interface `EJBQLExpressionVisitor`

    - #### visitSubstring

          public boolean visitSubstring​(EJBQLExpression expression,
                                        int finishedChildIndex)

      Specified by:
        `visitSubstring` in interface `EJBQLExpressionVisitor`

    - #### visitSubtract

          public boolean visitSubtract​(EJBQLExpression expression,
                                       int finishedChildIndex)

      Description copied from interface: `EJBQLExpressionVisitor`
      Called on visiting "subtract" expression and also after visiting every expression child.
      Specified by:
        `visitSubtract` in interface `EJBQLExpressionVisitor`
      Parameters:
        `expression` - an "subtract" node being visited.
        `finishedChildIndex` - "-1" when the expression node is visited for the first time, before its children; otherwise this is an index of a child just visited.

    - #### visitSum

          public boolean visitSum​(EJBQLAggregateColumn expression)

      Specified by:
        `visitSum` in interface `EJBQLExpressionVisitor`

    - #### visitTok

          public boolean visitTok​(EJBQLExpression expression)

      Specified by:
        `visitTok` in interface `EJBQLExpressionVisitor`

    - #### visitTrim

          public boolean visitTrim​(EJBQLExpression expression,
                                   int finishedChildIndex)

      Specified by:
        `visitTrim` in interface `EJBQLExpressionVisitor`

    - #### visitTrimBoth

          public boolean visitTrimBoth​(EJBQLExpression expression)

      Specified by:
        `visitTrimBoth` in interface `EJBQLExpressionVisitor`

    - #### visitTrimCharacter

          public boolean visitTrimCharacter​(EJBQLExpression expression)

      Specified by:
        `visitTrimCharacter` in interface `EJBQLExpressionVisitor`

    - #### visitTrimLeading

          public boolean visitTrimLeading​(EJBQLExpression expression)

      Specified by:
        `visitTrimLeading` in interface `EJBQLExpressionVisitor`

    - #### visitTrimTrailing

          public boolean visitTrimTrailing​(EJBQLExpression expression)

      Specified by:
        `visitTrimTrailing` in interface `EJBQLExpressionVisitor`

    - #### visitUpdate

          public boolean visitUpdate​(EJBQLExpression expression)

      Specified by:
        `visitUpdate` in interface `EJBQLExpressionVisitor`

    - #### visitUpdateField

          public boolean visitUpdateField​(EJBQLExpression expression,
                                          int finishedChildIndex)

      Specified by:
        `visitUpdateField` in interface `EJBQLExpressionVisitor`

    - #### visitUpdateItem

          public boolean visitUpdateItem​(EJBQLExpression expression,
                                         int finishedChildIndex)

      Specified by:
        `visitUpdateItem` in interface `EJBQLExpressionVisitor`

    - #### visitUpdateValue

          public boolean visitUpdateValue​(EJBQLExpression expression)

      Specified by:
        `visitUpdateValue` in interface `EJBQLExpressionVisitor`

    - #### visitUpper

          public boolean visitUpper​(EJBQLExpression expression,
                                    int finishedChildIndex)

      Specified by:
        `visitUpper` in interface `EJBQLExpressionVisitor`

    - #### visitWhere

          public boolean visitWhere​(EJBQLExpression expression)

      Specified by:
        `visitWhere` in interface `EJBQLExpressionVisitor`